#include <iostream>
#include <fstream>
#include <locale>
#include <string>

using namespace std;

int main( ) {
   try {
      locale loc("");
      cout << "Nazwa schematu lokalizacji = " << loc.name( ) << endl;

      locale locFr("french");
      locale locEn("english-american");
      locale locPl("polish");

      cout.imbue(locFr); // wymuszenie cout formatowania waciwego
                         // dla jzyka francuskiego

      cout << "3.14 (francuski) = " << 3.14 << endl;
      cout << "Nazwa = " << locFr.name( ) << endl;

      cout.imbue(locEn); // zmiana na jzyk angielski (w odmianie amerykaskiej)

      cout << "3.14 (angielski) = " << 3.14 << endl;
      cout << "Nazwa = " << locEn.name( ) << endl;

      cout.imbue(locPl); // a teraz na polski

      cout << "3.14 (polski) = " << 3.14 << endl;
      cout << "Nazwa = " << locPl.name( ) << endl;
   }
   catch (runtime_error& e) {
      // nieprawidowa nazwa schematu lokalizacji prowokuje
      // wyjtek runtime_error
      cerr << "Bd: " << e.what( ) << endl;
   }
}